#! /bin/sh

# Generate a list of distributed files w.r.t. a list of file which must
# be excluded.
# --------------------
# List all the headers in order to make them part of distribution.

# Use the C locale to have a deterministic sort.
export LC_ALL=C

if [ $# -ne 3 ]; then
  echo "$0 <scanned_dir> <output> <nodist-headers>"
  exit 1
fi

me=`basename $0`
scanned_dir=$1
output=$2
nodist_headers=$3
test -f "$nodist_headers" \
  || { echo "$me: Cannot find \`$nodist_headers' in `pwd`."; exit 1; }

echo "Generating $output..." >&2
rm -f "$output"
cat <<EOF >"$output"
## Generated by \`$me', do not edit by hand.

nobase_include_HEADERS = \\
EOF

find $scanned_dir -type f -a \( -name '*.hh' -o -name '*.hxx' \) \
  | sort						\
  | comm -23 - "$nodist_headers"			\
  | sed -e 's/$/ \\/g' >> $output

last_line=`tail -n 1 $output | sed -e 's/\\\//g'` # remove '\' in last line
sed '$d' < $output > $output.tmp # remove last line
mv $output.tmp $output
echo $last_line >> $output # put the cleaned last line back.
